Building React Apps with the Nx Standalone Setup

In this tutorial you'll learn how to use React with Nx in a "standalone" (non-monorepo) setup.

What are you going to learn?

  • how to create a new React application
  • how to run a single task (i.e. serve your app) or run multiple tasks in parallel
  • how to leverage code generators to scaffold components
  • how to modularize your codebase and impose architectural constraints for better maintainability
Looking for React monorepos?

Note, this tutorial sets up a repo with a single application at the root level that breaks out its code into libraries to add structure. If you are looking for a React monorepo setup then check out our React monorepo tutorial.

Note, while you could easily use Nx together with your manually set up React application, we're going to use the @nx/react plugin for this tutorial which provides some nice enhancements when working with React. Visit our "Why Nx" page to learn more about plugins and what role they play in the Nx architecture.

Final Code

Here's the source code of the final result for this tutorial.

Creating a new React App

Create a new standalone React application with the following command:

~โฏ

npx create-nx-workspace@latest myreactapp --preset=react-standalone

1 2NX Let's create a new workspace [https://nx.dev/getting-started/intro] 3 4โœ” Which bundler would you like to use? ยท vite 5โœ” Test runner to use for end to end (E2E) tests ยท cypress 6โœ” Default stylesheet format ยท css 7โœ” Set up CI with caching, distribution and test deflaking ยท github 8

You can choose any bundler you like. In this tutorial we're going to use Vite. The above command generates the following structure:

1โ””โ”€ myreactapp 2 โ”œโ”€ ... 3 โ”œโ”€ e2e 4 โ”‚ โ””โ”€ ... 5 โ”œโ”€ public 6 โ”‚ โ””โ”€ ... 7 โ”œโ”€ src 8 โ”‚ โ”œโ”€ app 9 โ”‚ โ”‚ โ”œโ”€ app.module.css 10 โ”‚ โ”‚ โ”œโ”€ app.spec.tsx 11 โ”‚ โ”‚ โ”œโ”€ app.tsx 12 โ”‚ โ”‚ โ””โ”€ nx-welcome.tsx 13 โ”‚ โ”œโ”€ assets 14 โ”‚ โ”œโ”€ main.tsx 15 โ”‚ โ””โ”€ styles.css 16 โ”œโ”€ index.html 17 โ”œโ”€ nx.json 18 โ”œโ”€ package.json 19 โ”œโ”€ project.json 20 โ”œโ”€ tsconfig.app.json 21 โ”œโ”€ tsconfig.json 22 โ”œโ”€ tsconfig.spec.json 23 โ””โ”€ vite.config.ts 24

The setup includes..

  • a new React application at the root of the Nx workspace (src/app)
  • a Cypress based set of e2e tests (e2e/)
  • Prettier preconfigured
  • ESLint preconfigured
  • Jest preconfigured

Let me explain a couple of things that might be new to you.

FileDescription
nx.jsonThis is where we fine-tune how Nx works. We define what cacheable operations there are, and configure our task pipeline. More on that soon.
project.jsonThis file is where you can modify the inferred tasks for the myreactapp project. More about this later.

Serving the App

The most common tasks are already mapped in the package.json file:

package.json
1{ 2 "name": "myreactapp", 3 "scripts": { 4 "start": "nx serve", 5 "build": "nx build", 6 "test": "nx test" 7 } 8 ... 9} 10

To serve your new React application, just run: npm start. Alternatively you can directly use Nx by using

โฏ

nx serve

Your application should be served at http://localhost:4200.

Nx uses the following syntax to run tasks:

Syntax for Running Tasks in Nx

Inferred Tasks

Nx identifies available tasks for your project from tooling configuration files, package.json scripts and the targets defined in project.json. To view the tasks that Nx has detected, look in the Nx Console project detail view or run:

โฏ

nx show project myreactapp --web

Project Details View (Simplified)

myreactapp

Root: .

Type: Application

Targets

  • build

    vite build

    Cacheable

If you expand the build task, you can see that it was created by the @nx/vite plugin by analyzing your vite.config.ts file. Notice the outputs are defined as {projectRoot}/dist/myreactapp. This value is being read from the build.outDir defined in your vite.config.ts file. Let's change that value in your vite.config.ts file:

vite.config.ts
1export default defineConfig({ 2 // ... 3 build: { 4 outDir: './build/myreactapp', 5 // ... 6 }, 7}); 8

Now if you look at the project details view, the outputs for the build target will say {projectRoot}/build/myreactapp. This feature ensures that Nx will always cache the correct files.

You can also override the settings for inferred tasks by modifying the targetDefaults in nx.json or setting a value in your project.json file. Nx will merge the values from the inferred tasks with the values you define in targetDefaults and in your specific project's configuration.

Testing and Linting - Running Multiple Tasks

Our current setup doesn't just come with targets for serving and building the React application, but also has targets for unit testing, e2e testing and linting. We can use the same syntax as before to run these tasks:

1nx test # runs tests using Vitest (or you can configure it to use Jest) 2nx lint # runs linting with ESLint 3nx e2e e2e # runs e2e tests with Cypress 4

More conveniently, we can also run them in parallel using the following syntax:

myreactappโฏ

nx run-many -t test lint e2e

1 2โœ” nx run e2e:lint (2s) 3โœ” nx run myreactapp:lint (2s) 4โœ” nx run myreactapp:test (2s) 5โœ” nx run e2e:e2e (6s) 6 7โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€” 8 9NX Successfully ran targets test, lint, e2e for 2 projects (7s) 10

Caching

One thing to highlight is that Nx is able to cache the tasks you run.

Note that all of these targets are automatically cached by Nx. If you re-run a single one or all of them again, you'll see that the task completes immediately. In addition, (as can be seen in the output example below) there will be a note that a matching cache result was found and therefore the task was not run again.

myreactappโฏ

nx run-many -t test lint e2e

1 2โœ” nx run e2e:lint [existing outputs match the cache, left as is] 3โœ” nx run myreactapp:lint [existing outputs match the cache, left as is] 4โœ” nx run myreactapp:test [existing outputs match the cache, left as is] 5โœ” nx run e2e:e2e [existing outputs match the cache, left as is] 6 7โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€” 8 9NX Successfully ran targets test, lint, e2e for 5 projects (54ms) 10 11Nx read the output from the cache instead of running the command for 10 out of 10 tasks. 12

Not all tasks might be cacheable though. You can configure the cache properties in the targets under targetDefaults in the nx.json file. You can also learn more about how caching works.

Nx Plugins? Why?

One thing you might be curious about is the inferred tasks. You may wonder why we are detecting tasks from your tooling configuration instead of directly defining them in package.json scripts or in the project.json file.

Nx understands and supports both approaches, allowing you to define tasks in your package.json and project.json files or have Nx plugins automatically detect them. The inferred tasks give you the benefit of automatically setting the Nx cache settings for you based on your tooling configuration. In this tutorial, we take advantage of those inferred tasks to demonstrate the full value of Nx plugins.

So, what are Nx Plugins? Nx Plugins are optional packages that extend the capabilities of Nx, catering to various specific technologies. For instance, we have plugins tailored to React (e.g., @nx/react), Vite (@nx/vite), Cypress (@nx/cypress), and more. These plugins offer additional features, making your development experience more efficient and enjoyable when working with specific tech stacks.

Visit our "Why Nx" page for more details.

Creating New Components

You can just create new React components as you normally would. However, Nx plugins usually also ship generators. They allow you to easily scaffold code, configuration or entire projects. To see what capabilities the @nx/react plugin ships, run the following command and inspect the output:

myreactappโฏ

npx nx list @nx/react

1 2NX Capabilities in @nx/react: 3 4 GENERATORS 5 6 init : Initialize the `@nrwl/react` plugin. 7 application : Create a React application. 8 library : Create a React library. 9 component : Create a React component. 10 redux : Create a Redux slice for a project. 11 storybook-configuration : Set up storybook for a React app or library. 12 component-story : Generate storybook story for a React component 13 stories : Create stories/specs for all components declared in an app or library. 14 component-cypress-spec : Create a Cypress spec for a UI component that has a story. 15 hook : Create a hook. 16 host : Generate a host react application 17 remote : Generate a remote react application 18 cypress-component-configuration : Setup Cypress component testing for a React project 19 component-test : Generate a Cypress component test for a React component 20 setup-tailwind : Set up Tailwind configuration for a project. 21 setup-ssr : Set up SSR configuration for a project. 22 federate-module : Federate a module. 23 24 EXECUTORS/BUILDERS 25 26 module-federation-dev-server : Serve a host or remote application. 27 module-federation-ssr-dev-server : Serve a host application along with it's known remotes. 28
Prefer a more visual UI?

If you prefer a more integrated experience, you can install the "Nx Console" extension for your code editor. It has support for VSCode, IntelliJ and ships a LSP for Vim. Nx Console provides autocompletion support in Nx configuration files and has UIs for browsing and running generators.

More info can be found in the integrate with editors article.

Run the following command to generate a new "hello-world" component. Note how we append --dry-run to first check the output.

myreactappโฏ

npx nx g @nx/react:component --directory=src/app/hello-world hello-world --dry-run

1NX Generating @nx/react:component 2 3โœ” Should this component be exported in the project? (y/N) ยท false 4โœ” Where should the component be generated? ยท src/app/hello-world/hello-world.tsx 5CREATE src/app/hello-world/hello-world.module.css 6CREATE src/app/hello-world/hello-world.spec.tsx 7CREATE src/app/hello-world/hello-world.tsx 8 9NOTE: The "dryRun" flag means no changes were made. 10

As you can see it generates a new component in the app/hello-world/ folder. If you want to actually run the generator, remove the --dry-run flag.

src/app/hello-world/hello-world.tsx
1import styles from './hello-world.module.css'; 2 3/* eslint-disable-next-line */ 4export interface HelloWorldProps {} 5 6export function HelloWorld(props: HelloWorldProps) { 7 return ( 8 <div className={styles['container']}> 9 <h1>Welcome to HelloWorld!</h1> 10 </div> 11 ); 12} 13 14export default HelloWorld; 15

Building the App for Deployment

If you're ready and want to ship your application, you can build it using

myreactappโฏ

npx nx build

1vite v4.3.5 building for production... 2โœ“ 33 modules transformed. 3dist/myreactapp/index.html 0.48 kB โ”‚ gzip: 0.30 kB 4dist/myreactapp/assets/index-e3b0c442.css 0.00 kB โ”‚ gzip: 0.02 kB 5dist/myreactapp/assets/index-378e8124.js 165.64 kB โ”‚ gzip: 51.63 kB 6โœ“ built in 496ms 7 8โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€” 9 10NX Successfully ran target build for project reactutorial (1s) 11

All the required files will be placed in the dist/myreactapp folder and can be deployed to your favorite hosting provider.

You're ready to go!

In the previous sections you learned about the basics of using Nx, running tasks and navigating an Nx workspace. You're ready to ship features now!

But there's more to learn. You have two possibilities here:

Modularizing your React App with Local Libraries

When you develop your React application, usually all your logic sits in the app folder. Ideally separated by various folder names which represent your "domains". As your app grows, this becomes more and more monolithic though.

1โ””โ”€ myreactapp 2 โ”œโ”€ ... 3 โ”œโ”€ src 4 โ”‚ โ”œโ”€ app 5 โ”‚ โ”‚ โ”œโ”€ products 6 โ”‚ โ”‚ โ”œโ”€ cart 7 โ”‚ โ”‚ โ”œโ”€ ui 8 โ”‚ โ”‚ โ”œโ”€ ... 9 โ”‚ โ”‚ โ””โ”€ app.tsx 10 โ”‚ โ”œโ”€ ... 11 โ”‚ โ””โ”€ main.tsx 12 โ”œโ”€ ... 13 โ”œโ”€ package.json 14 โ”œโ”€ ... 15

Nx allows you to separate this logic into "local libraries". The main benefits include

  • better separation of concerns
  • better reusability
  • more explicit "APIs" between your "domain areas"
  • better scalability in CI by enabling independent test/lint/build commands for each library
  • better scalability in your teams by allowing different teams to work on separate libraries

Creating Local Libraries

Let's assume our domain areas include products, orders and some more generic design system components, called ui. We can generate a new library for each of these areas using the React library generator:

1nx g @nx/react:library products --unitTestRunner=vitest --bundler=none --directory=modules/products 2nx g @nx/react:library orders --unitTestRunner=vitest --bundler=none --directory=modules/orders 3nx g @nx/react:library ui --unitTestRunner=vitest --bundler=none --directory=modules/shared/ui 4

Note how we use the --directory flag to place the libraries into a subfolder. You can choose whatever folder structure you like, even keep all of them at the root-level.

Running the above commands should lead to the following directory structure:

1โ””โ”€ myreactapp 2 โ”œโ”€ ... 3 โ”œโ”€ modules 4 โ”‚ โ”œโ”€ products 5 โ”‚ โ”‚ โ”œโ”€ ... 6 โ”‚ โ”‚ โ”œโ”€ project.json 7 โ”‚ โ”‚ โ”œโ”€ src 8 โ”‚ โ”‚ โ”‚ โ”œโ”€ index.ts 9 โ”‚ โ”‚ โ”‚ โ””โ”€ lib 10 โ”‚ โ”‚ โ”‚ โ”œโ”€ products.spec.ts 11 โ”‚ โ”‚ โ”‚ โ””โ”€ products.ts 12 โ”‚ โ”‚ โ”œโ”€ tsconfig.json 13 โ”‚ โ”‚ โ”œโ”€ tsconfig.lib.json 14 โ”‚ โ”‚ โ”œโ”€ tsconfig.spec.json 15 โ”‚ โ”‚ โ””โ”€ vite.config.ts 16 โ”‚ โ”œโ”€ orders 17 โ”‚ โ”‚ โ”œโ”€ ... 18 โ”‚ โ”‚ โ”œโ”€ project.json 19 โ”‚ โ”‚ โ”œโ”€ src 20 โ”‚ โ”‚ โ”‚ โ”œโ”€ index.ts 21 โ”‚ โ”‚ โ”‚ โ””โ”€ ... 22 โ”‚ โ”‚ โ””โ”€ ... 23 โ”‚ โ””โ”€ shared 24 โ”‚ โ””โ”€ ui 25 โ”‚ โ”œโ”€ ... 26 โ”‚ โ”œโ”€ project.json 27 โ”‚ โ”œโ”€ src 28 โ”‚ โ”‚ โ”œโ”€ index.ts 29 โ”‚ โ”‚ โ””โ”€ ... 30 โ”‚ โ””โ”€ ... 31 โ”œโ”€ src 32 โ”‚ โ”œโ”€ app 33 โ”‚ โ”‚ โ”œโ”€ hello-world 34 โ”‚ โ”‚ โ”‚ โ”œโ”€ hello-world.module.css 35 โ”‚ โ”‚ โ”‚ โ”œโ”€ hello-world.spec.tsx 36 โ”‚ โ”‚ โ”‚ โ””โ”€ hello-world.tsx 37 โ”‚ โ”‚ โ””โ”€ ... 38 โ”‚ โ”œโ”€ ... 39 โ”‚ โ””โ”€ main.tsx 40 โ”œโ”€ ... 41

Each of these libraries

  • has a project details view where you can see the available tasks (e.g. running tests for just orders: nx test orders)
  • has its own project.json file where you can customize targets
  • has a dedicated index.ts file which is the "public API" of the library
  • is mapped in the tsconfig.base.json at the root of the workspace

Importing Libraries into the React Application

All libraries that we generate automatically have aliases created in the root-level tsconfig.base.json.

tsconfig.base.json
1{ 2 "compilerOptions": { 3 ... 4 "paths": { 5 "@myreactapp/orders": ["modules/orders/src/index.ts"], 6 "@myreactapp/products": ["modules/products/src/index.ts"], 7 "@myreactapp/ui": ["modules/shared/ui/src/index.ts"] 8 }, 9 ... 10 }, 11} 12

Hence we can easily import them into other libraries and our React application. As an example, let's create and expose a ProductList component from our modules/products library. Either create it by hand or run

โฏ

nx g @nx/react:component product-list --directory=modules/products/src/lib/product-list

We don't need to implement anything fancy as we just want to learn how to import it into our main React application.

modules/products/src/lib/product-list/product-list.tsx
1import styles from './product-list.module.css'; 2 3/* eslint-disable-next-line */ 4export interface ProductListProps {} 5 6export function ProductList(props: ProductListProps) { 7 return ( 8 <div className={styles['container']}> 9 <h1>Welcome to ProductList!</h1> 10 </div> 11 ); 12} 13 14export default ProductList; 15

Make sure the ProductList is exported via the index.ts file of our products library. This is our public API with the rest of the workspace. Only export what's really necessary to be usable outside the library itself.

modules/products/src/index.ts
1export * from './lib/product-list/product-list'; 2

We're ready to import it into our main application now. First (if you haven't already), let's set up React Router.

โฏ

npm add react-router-dom

Configure it in the main.tsx.

src/main.tsx
1import { StrictMode } from 'react'; 2import { BrowserRouter } from 'react-router-dom'; 3import ReactDOM from 'react-dom/client'; 4 5import App from './app/app'; 6 7const root = ReactDOM.createRoot( 8 document.getElementById('root') as HTMLElement 9); 10 11root.render( 12 <StrictMode> 13 <BrowserRouter> 14 <App /> 15 </BrowserRouter> 16 </StrictMode> 17); 18

Then we can import the ProductList component into our app.tsx and render it via the routing mechanism whenever a user hits the /products route.

src/app/app.tsx
1import { Route, Routes } from 'react-router-dom'; 2 3// importing the component from the library 4import { ProductList } from '@myreactapp/products'; 5 6function Home() { 7 return <h1>Home</h1>; 8} 9 10export function App() { 11 return ( 12 <Routes> 13 <Route path="/" element={<Home />}></Route> 14 <Route path="/products" element={<ProductList />}></Route> 15 </Routes> 16 ); 17} 18 19export default App; 20

Serving your app (nx serve) and then navigating to /products should give you the following result:

products route

Let's apply the same for our orders library.

  • generate a new component OrderList in modules/orders and export it in the corresponding index.ts file
  • import it into the app.tsx and render it via the routing mechanism whenever a user hits the /orders route

In the end, your app.tsx should look similar to this:

src/app/app.tsx
1import { Route, Routes } from 'react-router-dom'; 2import { ProductList } from '@myreactapp/products'; 3import { OrderList } from '@myreactapp/orders'; 4 5function Home() { 6 return <h1>Home</h1>; 7} 8 9export function App() { 10 return ( 11 <Routes> 12 <Route path="/" element={<Home />}></Route> 13 <Route path="/products" element={<ProductList />}></Route> 14 <Route path="/orders" element={<OrderList />}></Route> 15 </Routes> 16 ); 17} 18 19export default App; 20

Visualizing your Project Structure

Nx automatically detects the dependencies between the various parts of your workspace and builds a project graph. This graph is used by Nx to perform various optimizations such as determining the correct order of execution when running tasks like nx build, identifying affected projects and more. Interestingly you can also visualize it.

Just run:

โฏ

nx graph

You should be able to see something similar to the following in your browser.

Loading...

Notice how ui is not yet connected to anything because we didn't import it in any of our projects.

Exercise for you: change the codebase such that ui is used by orders and products. Note: you need to restart the nx graph command to update the graph visualization or run the CLI command with the --watch flag.

Imposing Constraints with Module Boundary Rules

Once you modularize your codebase you want to make sure that the modules are not coupled to each other in an uncontrolled way. Here are some examples of how we might want to guard our small demo workspace:

  • we might want to allow orders to import from ui but not the other way around
  • we might want to allow orders to import from products but not the other way around
  • we might want to allow all libraries to import the ui components, but not the other way around

When building these kinds of constraints you usually have two dimensions:

  • type of project: what is the type of your library. Example: "feature" library, "utility" library, "data-access" library, "ui" library
  • scope (domain) of the project: what domain area is covered by the project. Example: "orders", "products", "shared" ... this really depends on the type of product you're developing

Nx comes with a generic mechanism that allows you to assign "tags" to projects. "tags" are arbitrary strings you can assign to a project that can be used later when defining boundaries between projects. For example, go to the project.json of your orders library and assign the tags type:feature and scope:orders to it.

modules/orders/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:orders"] 4} 5

Then go to the project.json of your products library and assign the tags type:feature and scope:products to it.

modules/products/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:products"] 4} 5

Finally, go to the project.json of the ui library and assign the tags type:ui and scope:shared to it.

modules/shared/ui/project.json
1{ 2 ... 3 "tags": ["type:ui", "scope:shared"] 4} 5

Notice how we assign scope:shared to our UI library because it is intended to be used throughout the workspace.

Next, let's come up with a set of rules based on these tags:

  • type:feature should be able to import from type:feature and type:ui
  • type:ui should only be able to import from type:ui
  • scope:orders should be able to import from scope:orders, scope:shared and scope:products
  • scope:products should be able to import from scope:products and scope:shared

To enforce the rules, Nx ships with a custom ESLint rule. Open the .eslintrc.base.json at the root of the workspace and add the following depConstraints in the @nx/enforce-module-boundaries rule configuration:

.eslintrc.base.json
1{ 2 ... 3 "overrides": [ 4 { 5 ... 6 "rules": { 7 "@nx/enforce-module-boundaries": [ 8 "error", 9 { 10 "enforceBuildableLibDependency": true, 11 "allow": [], 12 "depConstraints": [ 13 { 14 "sourceTag": "*", 15 "onlyDependOnLibsWithTags": ["*"] 16 }, 17 { 18 "sourceTag": "type:feature", 19 "onlyDependOnLibsWithTags": ["type:feature", "type:ui"] 20 }, 21 { 22 "sourceTag": "type:ui", 23 "onlyDependOnLibsWithTags": ["type:ui"] 24 }, 25 { 26 "sourceTag": "scope:orders", 27 "onlyDependOnLibsWithTags": [ 28 "scope:orders", 29 "scope:products", 30 "scope:shared" 31 ] 32 }, 33 { 34 "sourceTag": "scope:products", 35 "onlyDependOnLibsWithTags": ["scope:products", "scope:shared"] 36 }, 37 { 38 "sourceTag": "scope:shared", 39 "onlyDependOnLibsWithTags": ["scope:shared"] 40 } 41 ] 42 } 43 ] 44 } 45 }, 46 ... 47 ] 48} 49

To test it, go to your modules/products/src/lib/product-list/product-list.tsx file and import the OrderList from the orders project:

modules/products/src/lib/product-list/product-list.tsx
1import styles from './product-list.module.css'; 2 3// This import is not allowed ๐Ÿ‘‡ 4import { OrderList } from '@myreactapp/orders'; 5 6/* eslint-disable-next-line */ 7export interface ProductListProps {} 8 9export function ProductList(props: ProductListProps) { 10 return ( 11 <div className={styles['container']}> 12 <h1>Welcome to ProductList!</h1> 13 <OrderList /> 14 </div> 15 ); 16} 17 18export default ProductList; 19

If you lint your workspace you'll get an error now:

โฏ

nx run-many -t lint

1โœ” nx run myreactapp:lint [existing outputs match the cache, left as is] 2โœ” nx run e2e:lint [existing outputs match the cache, left as is] 3โœ” nx run ui:lint (1s) 4 5โœ– nx run products:lint 6 Linting "products"... 7 8 /Users/.../myreactapp/modules/products/src/lib/product-list/product-list.tsx 9 3:1 error A project tagged with "scope:products" can only depend on libs tagged with "scope:products", "scope:shared" @nx/enforce-module-boundaries 10 11 โœ– 1 problem (1 error, 0 warnings) 12 13 Lint errors found in the listed files. 14 15โœ” nx run orders:lint (1s) 16 17โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€”โ€” 18 19NX Ran target lint for 5 projects (1s) 20 21โœ” 4/5 succeeded [2 read from cache] 22 23โœ– 1/5 targets failed, including the following: 24 - nx run products:lint 25

If you have the ESLint plugin installed in your IDE you should immediately see an error:

ESLint module boundary error

Learn more about how to enforce module boundaries.

Migrating to a Monorepo

When you are ready to add another application to the repo, you'll probably want to move myreactapp to its own folder. To do this, you can run the convert-to-monorepo generator or manually move the configuration files.

You can also go through the full React monorepo tutorial

Setup CI for Your React App

This tutorial walked you through how Nx can improve the developer experience for local development, but Nx can also make a big difference in CI. Without adequate tooling, CI times tend to grow exponentially with the size of the codebase. Nx helps reduce wasted time in CI with the affected command and Nx Replay's remote caching. Nx also efficiently parallelizes tasks across machines with Nx Agents.

To set up Nx Cloud run:

โฏ

nx connect

And click the link provided. You'll need to follow the instructions on the website to sign up for your account.

Then you can set up your CI with the following command:

โฏ

nx generate ci-workflow --ci=github

Choose your CI provider

You can choose github, circleci, azure, bitbucket-pipelines, or gitlab for the ci flag.

This will create a default CI configuration that sets up Nx Cloud to use distributed task execution. This automatically runs all tasks on separate machines in parallel wherever possible, without requiring you to manually coordinate copying the output from one machine to another.

Check out one of these detailed tutorials on setting up CI with Nx:

Next Steps

Here's some things you can dive into next:

Also, make sure you

Building and Testing Angular Apps in Nx
In this tutorial, you'll learn how to create a new Angular monorepo using the Nx platform.
This tutorial requires a GitHub account to demonstrate the full value of Nx - including task running, caching, and CI integration.
What will you learn?
- how to create a new Angular workspace with GitHub Actions preconfigured
- how to run a single task (i.e. serve your app) or run multiple tasks in parallel
- how to modularize your codebase with local libraries for better code organization
- how to benefit from caching that works both locally and in CI
- how to set up self-healing CI to apply fixes directly from your local editor
Creating a new Angular Monorepo
To get started, let's create a new Angular monorepo with Nx Cloud and GitHub Actions preconfigured.
Create a new Angular monorepoWith Nx and GitHub Actions fully set up
You should now have a new workspace called acme
with Angular CLI, Jest, ESLint, and Prettier preconfigured.
1acme
2├── .github
3│ └── workflows
4│ └── ci.yml
5├── apps
6│ └── demo
7├── README.md
8├── eslint.config.mjs
9├── nx.json
10├── package-lock.json
11├── package.json
12├── tsconfig.base.json
13└── vitest.workspace.ts
14
The .github/workflows/ci.yml
file preconfigures your CI in GitHub Actions to run build and test through Nx.
The demo
app is created under the apps
directory as a convention. Later in this tutorial we'll create libraries under the packages
folder. In practice, you can choose any folder structure you like.
The nx.json
file contains configuration settings for Nx itself and global default settings that individual projects inherit.
Before continuing, it is important to make sure that your GitHub repository is connected to your Nx Cloud organization to enable remote caching and self-healing in CI.
Checkpoint: Workspace Created and Connected
At this point you should have:
- A new Nx workspace on your local machine with an Angular app in
apps/demo
- A new GitHub repository for the workspace with
.github/workflows/ci.yml
pipeline preconfigured - A workspace in Nx Cloud that is connected to the GitHub repository
You should see your workspace in your Nx Cloud organization.
If you do not see your workspace in Nx Cloud then please follow the steps outlined in the Nx Cloud setup.
Now, let's build some features and see how Nx helps get us to production faster.
Serving the App
To serve your new Angular app, run:
❯
npx nx serve demo
The app is served at http://localhost:4200.
Nx uses the following syntax to run tasks:
Project Configuration
The project tasks are defined in the project.json
file.
1{
2 "name": "demo",
3 ...
4 "targets": {
5 "build": { ... },
6 "serve": { ... },
7 "extract-i18n": { ... },
8 "lint": { ... },
9 "test": { ... },
10 "serve-static": { ... },
11 },
12}
13
Each target contains a configuration object that tells Nx how to run that target.
1{
2 "name": "angular-store",
3 ...
4 "targets": {
5 "serve": {
6 "executor": "@angular/build:dev-server",
7 "defaultConfiguration": "development",
8 "options": {
9 "buildTarget": "angular-store:build"
10 },
11 "configurations": {
12 "development": {
13 "buildTarget": "angular-store:build:development",
14 "hmr": true
15 },
16 "production": {
17 "buildTarget": "angular-store:build:production",
18 "hmr": false
19 }
20 }
21 },
22 ...
23 },
24}
25
The most critical parts are:
executor
- this is of the syntax<plugin>:<executor-name>
, where theplugin
is an NPM package containing an Nx Plugin and<executor-name>
points to a function that runs the task.options
- these are additional properties and flags passed to the executor function to customize it
To view all tasks for a project, look in the Nx Console project detail view or run:
❯
npx nx show project demo
demo
Root: apps/demo
Type:Application
Targets
build
@angular/build:application
Cacheable
Modularization with Local Libraries
When you develop your Angular application, usually all your logic sits in the app's src
folder. Ideally separated by various folder names which represent your domains or features. As your app grows, however, the app becomes more and more monolithic, which makes building and testing it harder and slower.
1acme
2├── apps
3│ └── demo
4│ └── src
5│ ├── app
6│ ├── cart
7│ ├── products
8│ ├── orders
9│ └── ui
10└── ...
11
Nx allows you to separate this logic into "local libraries." The main benefits include
- better separation of concerns
- better reusability
- more explicit private and public boundaries (APIs) between domains and features
- better scalability in CI by enabling independent test/lint/build commands for each library
- better scalability in your teams by allowing different teams to work on separate libraries
Create Local Libraries
Let's create a reusable design system library called ui
that we can use across our workspace. This library will contain reusable components such as buttons, inputs, and other UI elements.
1npx nx g @nx/angular:library packages/ui --unitTestRunner=vitest
2
Note how we type out the full path in the command to place the library into a subfolder. You can choose whatever folder structure you like to organize your projects.
Running the above command should lead to the following directory structure:
1acme
2├── apps
3│ └── demo
4├── packages
5│ └── ui
6├── eslint.config.mjs
7├── nx.json
8├── package-lock.json
9├── package.json
10├── tsconfig.base.json
11└── vitest.workspace.ts
12
Just as with the demo
app, Nx automatically infers the tasks for the ui
library from its configuration files. You can view them by running:
❯
npx nx show project ui
In this case, we have the lint
and test
tasks available, among other inferred tasks.
❯
npx nx lint ui
❯
npx nx test ui
Import Libraries into the Demo App
All libraries that we generate are automatically included in the TypeScript path mappings configured in the root-level tsconfig.base.json
.
1{
2 "compilerOptions": {
3 ...
4 "paths": {
5 "@acme/ui": ["packages/ui/src/index.ts"]
6 },
7 ...
8 },
9}
10
Hence, we can easily import them into other libraries and our Angular application.
You can see that the Ui
component is exported via the index.ts
file of our ui
library so that other projects in the repository can use it. This is our public API with the rest of the workspace and is enforced by the library's build configuration. Only export what's necessary to be usable outside the library itself.
1export * from './lib/ui/ui';
2
Let's add a simple Hero
component that we can use in our demo app.
1import { Component, Input, Output, EventEmitter } from '@angular/core';
2import { CommonModule } from '@angular/common';
3
4({
5 selector: 'lib-hero',
6 standalone: true,
7 imports: [CommonModule],
8 template: `
9 <div [ngStyle]="containerStyle">
10 <h1 [ngStyle]="titleStyle">{{ title }}</h1>
11 <p [ngStyle]="subtitleStyle">{{ subtitle }}</p>
12 <button (click)="handleCtaClick()" [ngStyle]="buttonStyle">
13 {{ cta }}
14 </button>
15 </div>
16 `,
17})
18export class Hero {
19 () title!: string;
20 () subtitle!: string;
21 () cta!: string;
22 () ctaClick = new EventEmitter<void>();
23
24 containerStyle = {
25 backgroundColor: '#1a1a2e',
26 color: 'white',
27 padding: '100px 20px',
28 textAlign: 'center',
29 };
30
31 titleStyle = {
32 fontSize: '48px',
33 marginBottom: '16px',
34 };
35
36 subtitleStyle = {
37 fontSize: '20px',
38 marginBottom: '32px',
39 };
40
41 buttonStyle = {
42 backgroundColor: '#0066ff',
43 color: 'white',
44 border: 'none',
45 padding: '12px 24px',
46 fontSize: '18px',
47 borderRadius: '4px',
48 cursor: 'pointer',
49 };
50
51 handleCtaClick() {
52 this.ctaClick.emit();
53 }
54}
55
Then, export it from index.ts
.
1export * from './lib/hero/hero';
2export * from './lib/ui/ui';
3
We're ready to import it into our main application now.
1import { Component } from '@angular/core';
2import { RouterOutlet } from '@angular/router';
3// importing the component from the library
4import { Hero } from '@acme/ui';
5
6({
7 selector: 'app-root',
8 standalone: true,
9 imports: [RouterOutlet, Hero],
10 template: `
11 <lib-hero
12 title="Welcmoe demo"
13 subtitle="Build something amazing today"
14 cta="Get Started"
15 ></lib-hero>
16 `,
17})
18export class App {}
19
Serve your app again (npx nx serve demo
) and you should see the new Hero component from the ui
library rendered on the home page.
If you have keen eyes, you may have noticed that there is a typo in the App
component. This mistake is intentional, and we'll see later how Nx can fix this issue automatically in CI.
Visualizing your Project Structure
Nx automatically detects the dependencies between the various parts of your workspace and builds a project graph. This graph is used by Nx to perform various optimizations such as determining the correct order of execution when running tasks like npx nx build
, identifying affected projects and more. Interestingly, you can also visualize it.
Just run:
❯
npx nx graph
You should be able to see something similar to the following in your browser.
Let's create a git branch with the new hero component so we can open a pull request later:
❯
git checkout -b add-hero-component
❯
git add .
❯
git commit -m 'add hero component'
Testing and Linting - Running Multiple Tasks
Our current setup not only has targets for serving and building the Angular application, but also has targets for unit testing, e2e testing and linting. The test
and lint
targets are defined in the application project.json
file. We can use the same syntax as before to run these tasks:
1npx nx test demo # runs the tests for demo
2npx nx lint ui # runs the linter on ui
3
More conveniently, we can also run tasks in parallel using the following syntax:
❯
npx nx run-many -t test lint
This is exactly what is configured in .github/workflows/ci.yml
for the CI pipeline. The run-many
command allows you to run multiple tasks across multiple projects in parallel, which is particularly useful in a monorepo setup.
There is a test failure for the demo
app due to the updated content. Don't worry about it for now, we'll fix it in a moment with the help of Nx Cloud's self-healing feature.
Local Task Cache
One thing to highlight is that Nx is able to cache the tasks you run.
Note that all of these targets are automatically cached by Nx. If you re-run a single one or all of them again, you'll see that the task completes immediately. In addition, (as can be seen in the output example below) there will be a note that a matching cache result was found and therefore the task was not run again.
~/acme❯
npx nx run-many -t test lint
1 ✔ nx run ui:lint
2 ✔ nx run ui:test
3 ✔ nx run demo:lint
4 ✖ nx run demo:test
5
6—————————————————————————————————————————————————————————————————————————————————————————————————————————
7
8 NX Ran targets test, lint for 2 projects (1s)
9
10 ✔ 3/4 succeeded [3 read from cache]
11
12 ✖ 1/4 targets failed, including the following:
13
14 - nx run demo:test
15
Again, the demo:test
task failed, but notice that the remaining three tasks were read from cache.
Not all tasks might be cacheable though. You can configure the cache
settings in the targetDefaults
property of the nx.json
file. You can also learn more about how caching works.
Self-Healing CI with Nx Cloud
In this section, we'll explore how Nx Cloud can help your pull request get to green faster with self-healing CI. Recall that our demo app has a test failure, so let's see how this can be automatically resolved.
The npx nx-cloud fix-ci
command that is already included in your GitHub Actions workflow (github/workflows/ci.yml
)is responsible for enabling self-healing CI and will automatically suggest fixes to your failing tasks.
1name: CI
2
3on:
4 push:
5 branches:
6 - main
7 pull_request:
8
9permissions:
10 actions: read
11 contents: read
12
13jobs:
14 main:
15 runs-on: ubuntu-latest
16 steps:
17 - uses: actions/checkout@v4
18 with:
19 filter: tree:0
20 fetch-depth: 0
21
22 - uses: actions/setup-node@v4
23 with:
24 node-version: 20
25 cache: 'npm'
26
27 - run: npm ci --legacy-peer-deps
28
29 - run: npx nx run-many -t lint test build
30
31 - run: npx nx-cloud fix-ci
32 if: always()
33
You will also need to install the Nx Console editor extension for VS Code, Cursor, or IntelliJ. For the complete AI setup guide, see our AI integration documentation.
Install Nx Console for VSCodeThe official VSCode extension for Nx.
Install Nx Console for JetBrainsAvailable for WebStorm, IntelliJ IDEA Ultimate and more!
Now, let's push the add-hero-component
branch to GitHub and open a new pull request.
❯
git push origin add-hero-component
❯
# Don't forget to open a pull request on GitHub
As expected, the CI check fails because of the test failure in the demo
app. But rather than looking at the pull request, Nx Console notifies you that the run has completed, and that it has a suggested fix for the failing test. This means that you don't have to waste time babysitting your PRs, and the fix can be applied directly from your editor.
Fix CI from Your Editor
From the Nx Console notification, you can click Show Suggested Fix
button. Review the suggested fix, which in this case is to change the typo Welcmoe
to the correct Welcome
spelling. Approve this fix by clicking ApplyFix
and that's it!
You didn't have to leave your editor or do any manual work to fix it. This is the power of self-healing CI with Nx Cloud.
Remote Cache for Faster Time To Green
After the fix has been applied and committed, CI will re-run automatically, and you will be notified of the results in your editor.
When you click View Results
to show the run in Nx Cloud, you'll notice something interesting. The lint and test tasks for the ui
library were read from remote cache and did not have to run again, thus each taking less than a second to complete.
This happens because Nx Cloud caches the results of tasks and reuses them across different CI runs. As long as the inputs for each task have not changed (e.g. source code), then their results can be replayed from Nx Cloud's Remote Cache. In this case, since the last fix was applied only to the demo
app's source code, none of the tasks for ui
library had to be run again.
This significantly speeds up the time to green for your pull requests, because subsequent changes to them have a good chance to replay tasks from cache.
Outputs from cached tasks, such as the dist
folder for builds or coverage
folder for tests, are also read from cache. Even though a task was not run again, its outputs are available. The Cache Task Results page provides more details on caching.
This pull request is now ready to be merged with the help of Nx Cloud's self-healing CI and remote caching.
Next Steps
Here are some things you can dive into next:
- Read more about how Nx compares to the Angular CLI
- Learn more about the underlying mental model of Nx
- Learn about popular generators such as how to setup Tailwind
- Learn how to migrate your existing Angular CLI repo to Nx
- Learn about enforcing boundaries between projects
- Setup Storybook for our shared UI library
Also, make sure you
- ⭐️ Star us on GitHub to show your support and stay updated on new releases!
- Join the Official Nx Discord Server to ask questions and find out the latest news about Nx.
- Follow Nx on Twitter to stay up to date with Nx news
- Read our Nx blog
- Subscribe to our Youtube channel for demos and Nx insights